@echo off

setlocal ENABLEDELAYEDEXPANSION
set basedir=%cd%

set user=tipadmin
set passwd=tippass
if not "%1" == "" (
	set user=%1
)
if not "%2" == "" (
	set passwd=%2
)
set ifix=7311-0001
set full=7.3.1.1

echo Searching for installed components...

pushd "%SI_PATH%\bin" 2>nul
if ERRORLEVEL 1 (
	pushd "%USERPROFILE%\acsi_%USERNAME%" 2>nul
	if ERRORLEVEL 1 (
		pushd "%PROGRAMFILES(x86)%\IBM\Common\acsi\bin" 2>nul
		if ERRORLEVEL 1 (
			pushd "%PROGRAMFILES%\IBM\Common\acsi\bin"
			if ERRORLEVEL 1 (
				echo Unable to find DE
				exit /b 1
			)
		)
	)
)
call ..\setenv.cmd
set patched=0
for /f "delims=, tokens=2,4,5,6" %%i in ('de_lsrootiu.cmd ^| find "IU,TUAM_" ^| sort') do (
    set ver=%%j
    if "!ver!" == "%full%" (
		if exist "%basedir%\%%i-%ifix%\META-INF\." (
		  if not exist "%%k\_uninst\fixes\ifix%ifix%\%%i\packagedIU.xml" (
			echo Applying patch for %%i
			pushd "%basedir%\%%i-%ifix%\META-INF"
			if "%%i" == "TUAM_UI" (
				call "%%k\bin\setupEnv"
			    set uid=%%l
				echo Variable#RootIUTypeID[!uid:~0,32!,%%i-%ifix%]#IAGLOBAL_TIP_HOME=!TIP_HOME:\=\\!> var.properties
				echo Variable#RootIUTypeID[!uid:~0,32!,%%i-%ifix%]#shExt=bat>> var.properties
				call manageIU.bat -o update -u true  -i var.properties -r "!TUAM_HOME!" -p packagedIU.xml 1>>!TUAM_HOME!\logs\ifix_%%i-%ifix%.log 2>&1
				set status=!ERRORLEVEL!
				del /q var.properties
			) else (
				set TUAM_HOME=%%k
				call manageIU.bat -o update -r "!TUAM_HOME!" -p packagedIU.xml -u true 1>>!TUAM_HOME!\logs\ifix_%%i-%ifix%.log 2>&1
				set status=!ERRORLEVEL!
			)
			if not !status! == 0 (
				echo Patch failed
				exit /b 1
			)
			mkdir "!TUAM_HOME!\_uninst\fixes\ifix%ifix%\%%i" 2>nul
			copy * "!TUAM_HOME!\_uninst\fixes\ifix%ifix%\%%i" >nul
			popd
			set /a patched+=1
		  )
		)
	)
)

popd
if %patched% == 0 (
   echo SCCM Release %full% must be installed to install this interim fix.
   echo Please install this version before attempting to install this fix.
   echo Fix has not been applied successfully.
   exit /b 1
)

endlocal

